/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <paum1202@usherbrooke.ca> wrote this file.  As long as you retain this notice you
 * can do whatever you want with this stuff. If we meet some day, and you think
 * this stuff is worth it, you can buy me a beer in return. -violette paulin 
 * ----------------------------------------------------------------------------
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

/* nuke sign from signed char */
#define REMOVE_SIGN(x) ( \
	((x) & ~ (1u << 8))\
)

#define SIZE_ALPH 26
#define SIZE_MSG 32
#define SIZE_OTP 64

static char			*e1(char *, char);
static char			*d1(char *, char);
static inline char	 gen1();

static char			*e2(char *, char *);
static char			*d2(char *, char *);
static char			*gen2();

static char			*e3(char *, char *);
static char			*d3(char *, char *);
static char			*gen3();
static void			 eve_shenanigans(char *);

static inline char	 gen_char();
static inline char	 gen_byte();
static void			 print_hex(char *);

int
main(int argc, char *argv[])
{
	srand(time(0)); /* init rand */


#ifdef PART1
	printf("-------PART 1-------\n");
	int key = gen1();
	/* SYMBOLS */
	char msg[] = "coding w/ freebsd style :)";
	printf("key: %d\n", key);
	printf("msg before: %s\n", msg);
	char *cypher = e1(msg, key);
	printf("cypher: %s\n", cypher);
	char *res = d1(cypher, key);
	printf("msg after: %s\n", res);

	free(cypher);
	free(res);

	/* MESSAGE */
	/* len = 32 (dont forget nullbyte!) */
	char msg32[] = "ceciestlemessageclairadechiffre";
	printf("key: %d\n", key);
	printf("msg before: %s\n", msg32);
	char *cypher32 = e1(msg32, key);
	printf("cypher: %s\n", cypher32);
	char *res32 = d1(cypher32, key);
	printf("msg after: %s\n", res32);

	free(cypher32);
	free(res32);
#endif

#ifdef PART2
	/* PART 2 */
	printf("-------PART 2-------\n");
	char *key_otp = gen2();

	/* 64 value max */
	char msg_otp[] = 
			"ceciestlemessageclairadechiffreilcomporte64charcestplutotlongxd";
	printf("key: %s\n", key_otp);
	printf("key as hex: ");
	print_hex(key_otp);
	printf("msg before: %s\n", msg_otp);
	printf("msg as hex: ");
	print_hex(msg_otp);
	char *cypher_otp = e2(msg_otp, key_otp);
	printf("cypher: %s\n", cypher_otp);
	printf("cypher as hex: ");
	print_hex(cypher_otp);
	char *res_otp = d2(cypher_otp, key_otp);
	printf("msg after: %s\n", res_otp);

	free(cypher_otp);
	free(res_otp);
	free(key_otp);

#endif

#ifdef PART3
	/* PART 3 */
	printf("-------PART 3-------\n");
	char *key_vignere = gen3();
	char msg_vignere[] = "ceciestlemessageclairadechiffre";

	printf("key: %s\n", key_vignere);
	printf("key as hex: ");
	print_hex(key_vignere);
	printf("msg before: %s\n", msg_vignere);
	printf("msg as hex: ");
	print_hex(msg_vignere);
	char *cypher_vignere = e3(msg_vignere, key_vignere);
	printf("cypher: %s\n", cypher_vignere);
	printf("cypher as hex: ");
	print_hex(cypher_vignere);
	char *res_vignere = d3(cypher_vignere, key_vignere);
	printf("msg after: %s\n", res_vignere);

	free(res_vignere);
	free(cypher_vignere);
	free(key_vignere);
#endif

#ifdef PART3C
	/* PART 3 */
	printf("-------PART3C-------\n");
	char *key_vignere = gen3();
	char msg_vignere[] = "ceciestlemessageclairadechiffre";

	printf("key: %s\n", key_vignere);
	printf("msg before: %s\n", msg_vignere);
	char *cypher_vignere = e3(msg_vignere, key_vignere);
	printf("cypher: %s\n", cypher_vignere);

	eve_shenanigans(cypher_vignere);
	printf("cypher tempered by Eve: %s\n", cypher_vignere);

	char *res_vignere = d3(cypher_vignere, key_vignere);
	printf("msg after: %s\n", res_vignere);

	free(res_vignere);
	free(cypher_vignere);
	free(key_vignere);
#endif

	return 0;
}

static char*
e1(char *clearText, char key)
{
	char *res = (char *)calloc(strlen(clearText) + 1, 1);
	for (unsigned short k  = 0 ; clearText[k] != '\0' ; ++k) {
		if (clearText[k] >= 'a' && clearText[k] <= 'z') /* we encrypt a-z */
			res[k] = (clearText[k] - 'a' + key) % 26 + 'a'; /* sign always + */
		else 
			res[k] = clearText[k];
	}
	return res;
}

static char*
d1(char *cypher, char key)
{
	char *res = (char *)calloc(strlen(cypher) + 1, 1);
	for (unsigned short k = 0; cypher[k] != '\0' ; ++k) {
		if (cypher[k] >= 'a' && cypher[k] <= 'z') {/* we decrypt a-z */
			/* in C, % is the rest, not modulo. We take care of the sign by
			 * always setting the signed bit to false :) */
			res[k] = 'a' + REMOVE_SIGN(cypher[k] - 'a' - key) % 26;
		}
		else 
			res[k] = cypher[k];
	}
	return res;
}

static inline char
gen1()
{
	return rand() % SIZE_ALPH;
}

static inline char*
e2(char *cypher, char *pad)
{
	char *res = (char *)calloc(SIZE_OTP, 1);
	/* loop unwraping, might help cpu / compilator to use parallelisation */
	for (unsigned char k = 0 ; k <= SIZE_OTP - 8 ; k = k + 8) {
		res[k] = cypher[k] ^ pad[k];
		res[k + 1] = cypher[k + 1] ^ pad[k + 1];
		res[k + 2] = cypher[k + 2] ^ pad[k + 2];
		res[k + 3] = cypher[k + 3] ^ pad[k + 3];
		res[k + 4] = cypher[k + 4] ^ pad[k + 4];
		res[k + 5] = cypher[k + 5] ^ pad[k + 5];
		res[k + 6] = cypher[k + 6] ^ pad[k + 6];
		res[k + 7] = cypher[k + 7] ^ pad[k + 7];
	}
	res[SIZE_OTP - 1] = '\0';
	return res;
}

static inline char*
d2(char *clearText, char *pad)
{
	char *res = (char *)calloc(SIZE_OTP, 1);
	/* loop unwraping, might help cpu / compilator to use parallelisation 
	 * NOTE prob gcc / clag already does that as a default, now we sure */
	for (unsigned char k = 0 ; k <= SIZE_OTP - 8 ; k = k + 8) {
		res[k] = clearText[k] ^ pad[k];
		res[k + 1] = clearText[k + 1] ^ pad[k + 1];
		res[k + 2] = clearText[k + 2] ^ pad[k + 2];
		res[k + 3] = clearText[k + 3] ^ pad[k + 3];
		res[k + 4] = clearText[k + 4] ^ pad[k + 4];
		res[k + 5] = clearText[k + 5] ^ pad[k + 5];
		res[k + 6] = clearText[k + 6] ^ pad[k + 6];
		res[k + 7] = clearText[k + 7] ^ pad[k + 7];
	}
	res[SIZE_OTP - 1] = '\0';
	return res;
}

static char*
gen2()
{
	char *res = (char *)calloc(sizeof(char) * SIZE_OTP, 1);
	for (unsigned char k = 0 ; k <= SIZE_OTP - 8 ; k = k + 8) {
		res[k] = gen_byte();
		res[k + 1] = gen_byte();
		res[k + 2] = gen_byte();
		res[k + 3] = gen_byte();
		res[k + 4] = gen_byte();
		res[k + 5] = gen_byte();
		res[k + 6] = gen_byte();
		res[k + 7] = gen_byte();
	}

	res[SIZE_OTP - 1] = '\0';

	return res;
}

static inline char
gen_byte()
{
	return rand() % 256;
}

static char*
e3(char *cypher, char *key)
{
	char *res = (char *)calloc(sizeof(char) * SIZE_MSG, 1);
	for(unsigned char k = 0 ; k <= SIZE_MSG - 8 ; k = k + 8) {
		/* we remove 2*a since cypher AND key contain 'a' */
		res[k] = (cypher[k] + key[k] - 2 * 'a') % SIZE_ALPH + 'a';
		res[k + 1] = (cypher[k + 1] + key[k + 1] - 2 * 'a') % SIZE_ALPH + 'a';
		res[k + 2] = (cypher[k + 2] + key[k + 2] - 2 * 'a') % SIZE_ALPH + 'a';
		res[k + 3] = (cypher[k + 3] + key[k + 3] - 2 * 'a') % SIZE_ALPH + 'a';
		res[k + 4] = (cypher[k + 4] + key[k + 4] - 2 * 'a') % SIZE_ALPH + 'a';
		res[k + 5] = (cypher[k + 5] + key[k + 5] - 2 * 'a') % SIZE_ALPH + 'a';
		res[k + 6] = (cypher[k + 6] + key[k + 6] - 2 * 'a') % SIZE_ALPH + 'a';
		res[k + 7] = (cypher[k + 7] + key[k + 7] - 2 * 'a') % SIZE_ALPH + 'a';
	}
	res[SIZE_MSG - 1] = '\0';

	return res;
}

static char*
d3(char *cypher, char *key)
{
	char *res = (char *)calloc(sizeof(char) * SIZE_MSG, 1);
	for(unsigned char k = 0 ; k <= SIZE_MSG - 8 ; k = k + 8) {
		/* we DONT remove 'a' since cypher AND key contain 'a' */
		res[k] = REMOVE_SIGN(cypher[k] - key[k])  % SIZE_ALPH + 'a';
		res[k + 1] = REMOVE_SIGN(cypher[k + 1] - key[k + 1]) % SIZE_ALPH + 'a';
		res[k + 2] = REMOVE_SIGN(cypher[k + 2] - key[k + 2]) % SIZE_ALPH + 'a';
		res[k + 3] = REMOVE_SIGN(cypher[k + 3] - key[k + 3]) % SIZE_ALPH + 'a';
		res[k + 4] = REMOVE_SIGN(cypher[k + 4] - key[k + 4]) % SIZE_ALPH + 'a';
		res[k + 5] = REMOVE_SIGN(cypher[k + 5] - key[k + 5]) % SIZE_ALPH + 'a';
		res[k + 6] = REMOVE_SIGN(cypher[k + 6] - key[k + 6]) % SIZE_ALPH + 'a';
		res[k + 7] = REMOVE_SIGN(cypher[k + 7] - key[k + 7]) % SIZE_ALPH + 'a';
	}
	res[SIZE_MSG - 1] = '\0';

	return res;
}

static inline char
gen_char()
{
	return rand() % SIZE_ALPH;
}

static char*
gen3()
{
	char *res = (char *)calloc(sizeof(char) * SIZE_MSG, 1);
	for (unsigned char k = 0 ; k <= SIZE_MSG - 8 ; k = k + 8) {
		res[k] = gen_char() + 'a';
		res[k + 1] = gen_char() + 'a';
		res[k + 2] = gen_char() + 'a';
		res[k + 3] = gen_char() + 'a';
		res[k + 4] = gen_char() + 'a';
		res[k + 5] = gen_char() + 'a';
		res[k + 6] = gen_char() + 'a';
		res[k + 7] = gen_char() + 'a';
	}

	res[SIZE_MSG - 1] = '\0';
	return res;
}

static void
eve_shenanigans(char *cypher)
{
	unsigned short k		= 0;
	unsigned short c_count	= 0;

	while (cypher[k] != '\0' && c_count < 2) {
		if (cypher[k] == 'c')
			++c_count;
		++k;
	}

	while (cypher[k] != '\0') {
		if (cypher[k] == 'c')
			cypher[k] += 9;
		++k;
	}

	while (cypher[k] != '\0') {
		if (cypher[k] == 'c')
			cypher[k] += 18;
		++k;
	}
}

static void
print_hex(char *str)
{
	short k = 0;
	while (str[k] != '\0') {
		printf("%02X ", str[k] & 0xff);
		++k;
	}
	printf("\n");
}
